
Name: ocaml
Version: 3.06
Release: alt4

Summary: The Objective Caml compiler and programming environment

License: QPL & LGPL
Group: Development/Other
Obsoletes: ocaml-emacs
AutoReq: yes, noshell
%set_verify_elf_method relaxed

Url: http://caml.inria.fr/

Source0: ocaml-%version.tar.bz2
Source1: ftp://ftp.inria.fr/lang/caml-light/ocaml-3.06-refman.html.tar.gz
Source2: ftp://ftp.inria.fr/lang/caml-light/ocaml-3.06-refman.pdf
Source4: %name.menu
Source5: http://caml.inria.fr/oreilly-book/ocaml-ora-book.pdf

Patch5: camlp4_noopt-3.04+7.patch
Patch6: ocaml-3.04+7-private.patch
Patch7: ocaml-3.04+9-filename.patch
Patch8: ocaml-3.04+7-threadhack.patch
Patch9: ocaml-3.04+10-odochack.patch
Patch11: ocaml-3.04+10-stdlibdoc.patch
Patch12: labltk-tk84.patch

BuildRequires: db2-devel gdbm-devel libncurses-devel tetex-latex tetex-dvips tk-devel >= 8.4.0-alt1 XFree86-devel
#BuildRequires: emacs
Requires: ocaml-runtime = %version-%release

%package doc
Summary: Documentation for OCaml
Group: Development/Other
Requires: %name = %version-%release

%package -n camlp4
Summary: Preprocessor for OCaml
Group: Development/Other
Requires: %name = %version-%release

%package -n labltk
Summary: Tk toolkit binding for OCaml
Group: Development/Other
Requires: %name = %version-%release
Obsoletes: ocamltk, camltk
Provides: ocamltk = %version

%package -n ocaml-runtime
Summary: Runtime part of the OCaml system
Group: Development/Other
Requires: %name = %version-%release

%description
Objective Caml is a high-level, strongly-typed, functional and object-oriented
programming language from the ML family of languages.

This package comprises two batch compilers (a fast bytecode compiler and an
optimizing native-code compiler), an interactive toplevel system, Lex&Yacc
tools, a replay debugger, and a comprehensive library.

%description doc
Documentation for OCaml and O'Relly book translation

%description -n camlp4
Preprocessor for OCaml

%description -n labltk
Tk toolkit binding for OCaml

%description -n ocaml-runtime
Runtime part for the both bytecode and some native compiled
binaries.

%prep
%setup -q -T -b 0
%setup -q -T -D -a 1

### It was a stupid patch. Forget it.
# %patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch11 -p1
%patch12 -p0

# grrr ...
#%__cat <<EOF |ed - emacs/Makefile
#%s|\(--batch \)|\1--no-site-file |
#wq
#EOF

cp %SOURCE2 %SOURCE5 ./

%build
%add_optflags -DUSE_NON_CONST
./configure -with-pthread -bindir %_bindir -libdir %_libdir/ocaml -mandir %_mandir
make BYTECCCOMPOPTS="%optflags" NATIVECCCOMPOPTS="%optflags" world opt opt.opt
(cd ocamldoc; make stdlib_man stdlib.ps)
mv ocamldoc/stdlib.ps ./
mv ocamldoc/stdlib.pdf ./

%install
make install BINDIR=%buildroot%_bindir LIBDIR=%buildroot%_libdir/ocaml MANDIR=%buildroot%_mandir
mkdir -p %buildroot%_libdir/ocaml/site-lib/

# (cd emacs; make install install-ocamltags BINDIR=%buildroot%_bindir EMACSDIR=%buildroot%_datadir/emacs/site-lisp)

perl -pi -e "s|$RPM_BUILD_ROOT||" $RPM_BUILD_ROOT%_libdir/ocaml/ld.conf

## only keep the binary versions (which are much faster, and have no drawbacks (?))
#### NO WAY. THEY HAVE SOME... (e.g. threads program in bytecode) ####
#for i in $RPM_BUILD_ROOT%_bindir/*.opt ; do
#  nonopt=`echo $i | sed "s/.opt$//"`
#  rm -f $nonopt
#  ln -s `basename $i` $nonopt
#done

#rm -f $RPM_BUILD_ROOT%_bindir/ocamlc
#rm -f $RPM_BUILD_ROOT%_bindir/ocamlopt
#ln -s ocamlc.opt $RPM_BUILD_ROOT%_bindir/ocamlc
#ln -s ocamlopt.opt $RPM_BUILD_ROOT%_bindir/ocamlopt

#install -d $RPM_BUILD_ROOT%_sysconfdir/emacs/site-start.d
#cat <<EOF >$RPM_BUILD_ROOT%_sysconfdir/emacs/site-start.d/%name.el
#(require 'caml-font)
#(autoload 'caml-mode "caml" "Caml editing mode" t)
#(add-to-list 'auto-mode-alist '("\\\\.mli?$" . caml-mode))
#EOF

# menu (kept in case we want to use it again one day)
install -d $RPM_BUILD_ROOT%_menudir
install -m 644 %SOURCE4 $RPM_BUILD_ROOT%_menudir/%name

export EXCLUDE_FROM_STRIP="ocamldebug ocamlbrowser ocamlc ocamlopt"

rm -f %name.list
n="labltk|camlp4|ocamlbrowser|stublibs|ocamlrun|ld.conf"
(cd $RPM_BUILD_ROOT ; find usr/bin ! -type d -printf "/%%p\n" | egrep -v $n) >> %name.list
(cd $RPM_BUILD_ROOT ; find usr/lib/ocaml ! -type d -printf "/%%p\n" | egrep -v $n) >> %name.list
#(cd $RPM_BUILD_ROOT ; find usr/lib/ocaml   -type d -printf "%%%%dir /%%p\n" | egrep -v $n) >> %name.list
(cd $RPM_BUILD_ROOT ; find usr/lib/ocaml/stublibs -printf "/%%p\n" | egrep -v "labltk|camlp4") > run.list

%files -f %name.list
%doc Changes LICENSE README
%_mandir/man1/ocaml*
%_mandir/man1/ocpp*
%_mandir/mano/*
# %_datadir/emacs/site-lisp/*
# %config(noreplace) %_sysconfdir/emacs/site-start.d/*

%files doc
%doc htmlman/* stdlib.ps stdlib.pdf ocaml-3.06-refman.pdf ocaml-ora-book.pdf

%files -n ocaml-runtime -f run.list
%_bindir/ocamlrun
%dir %_libdir/ocaml
%dir %_libdir/ocaml/stublibs
%dir %_libdir/ocaml/site-lib
%_libdir/ocaml/ld.conf

%files -n labltk
%doc otherlibs/labltk/README otherlibs/labltk/examples_labltk otherlibs/labltk/examples_camltk
%_bindir/*labltk*
%_bindir/ocamlbrowser
%_libdir/ocaml/*labltk*
%_libdir/ocaml/stublibs/dlllabltk.so

%files -n camlp4
%_mandir/man?/*camlp4*
%_bindir/*camlp4*
%_libdir/ocaml/camlp4

%changelog

* Tue Oct 22 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.06-alt4
- O'Relly book included in the docs package
- Some minor cleanups

* Fri Oct  4 2002 Sergey Bolshakov <s.bolshakov@belcaf.com> 3.06-alt3
- rebuilt with tcl 8.4

* Thu Sep 26 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.06-alt2
- tcllibdir in RPATH problem fixed
- now camltk library interface is emulated by labltk

* Tue Aug 20 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.06-alt1
- Bugfix release 3.06
- We have bytecode binaries again

* Mon Aug 12 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.05-alt3
- Ocaml package splitted: now we have runtime and
- development parts separated

* Wed Jul 31 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.05-alt2
- critical bugfix (in the bytecode runtime)

* Mon Jul 29 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.05-alt1
- New Objective Caml released: 3.05.
- Camlp4 manpages hack is obsolete now.

* Mon Jul 15 2002 Sergey Bolshakov <s.bolshakov@belcaf.com> 3.04_15-alt4
- rebuilt with new tcl layout

* Mon Jun 24 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.04_15-alt2
- CVS version 3.04+15
- no more emacs mode installed.

* Tue May 14 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.04_10-alt5
- CVS version of OCaml (3.04+10)
- naive patch about stdlib manuals (odoc bug?)
- pdf and postscript stdlib manual
- pdf ocaml reference manual moved to the ocaml-doc subpackage
- ldconf patch (to simplify installation of packages with dynamic libraries)

* Tue Apr 16 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.04+9-alt8
- CVS version of OCaml (3.04+9),
- bytecode versions of compilers now included (due to the problem
   with threads).
- Threadhack patch from vsu <vsu@mivlgu.murom.ru>

* Wed Apr 3 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.04+8-alt1
- CVS version of OCaml (3.04+8), with ocamldoc officialy included

* Sat Mar 2 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.04+7-alt1
- CVS version of OCaml (3.04+7), shared patch and patch_record
  completely disabled.

* Mon Feb 4 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.04-alt4
- Shared patch commented out (can't fix a bug with string_of_int)...
- make opt is now disabled for camlp4
- ocamltk renamed to labltk

* Wed Jan 23 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.04-alt3
- patch_record added

* Thu Jan 10 2002 Vitaly Lugovsky <warlock@skeptik.net> 3.04-vsl2
- Shared patch
- GCC 2.96 bug workaround patch
- -with-pthread
- PDF documentation included
- no-opt for debug and profile patch removed (what is it for?!?)
- installation/uninstallation of INFO removed

* Wed Jan 09 2002 Stanislav Ievlev <inger@altlinux.ru> 3.04-alt1
- 3.04. MDK merges

* Wed Aug 08 2001 Stanislav Ievlev <inger@altlinux.ru> 3.02-alt1
- 3.02

* Mon Jul 23 2001 Sergie Pugachev <fd_rag@altlinux.ru> 3.01-alt1
new version

* Sun Jan 14 2001 AEN <aen@logic.ru>
- RE adaptation

* Thu Nov  2 2000 Pixel <pixel@mandrakesoft.com> 3.00-23mdk
- fix silly #define clashing with new glibc

* Tue Oct 10 2000 Pixel <pixel@mandrakesoft.com> 3.00-22mdk
- add ocamltags (needs emacs)

* Mon Sep  4 2000 Pixel <pixel@mandrakesoft.com> 3.00-21mdk
- rebuild with spec-helper fixed

* Tue Aug 29 2000 Pixel <pixel@mandrakesoft.com> 3.00-20mdk
- fix info pages

* Tue Aug 29 2000 Pixel <pixel@mandrakesoft.com> 3.00-19mdk
- remove menu entry

* Wed Aug 23 2000 Pixel <pixel@mandrakesoft.com> 3.00-18mdk
- add packager

* Wed Aug 23 2000 Pixel <pixel@mandrakesoft.com> 3.00-17mdk
- add obsolete %name-emacs

* Tue Aug 22 2000 Pixel <pixel@mandrakesoft.com> 3.00-16mdk
- nicer site-start.d/ocaml.el (use add-to-list)

* Tue Aug 22 2000 Pixel <pixel@mandrakesoft.com> 3.00-15mdk
- fix missing %%config, add install info

* Tue Aug 22 2000 Pixel <pixel@mandrakesoft.com> 3.00-14mdk
- use %_sysconfdir/emacs/site-start.d for the caml-mode.el
- merge %name and %name-emacs

* Mon Aug 07 2000 Frederic Lepied <flepied@mandrakesoft.com> 3.00-13mdk
- automatically added BuildRequires

* Tue Aug 01 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 3.00-12mdk
- relink with the new and shiny tcltk

* Wed Jul 26 2000 Pixel <pixel@mandrakesoft.com> 3.00-11mdk
- use %%optflags with omit-frame-buffer removed

* Tue Jul 25 2000 Pixel <pixel@mandrakesoft.com> 3.00-10mdk
- use %%optflags (so that there is -mieee on alpha)

* Sat Jul 22 2000 Pixel <pixel@mandrakesoft.com> 3.00-9mdk
- patch for camldebug.el to workaround the silly ocamldebug command not looking
in cwd

* Wed Jul 19 2000 Pixel <pixel@mandrakesoft.com> 3.00-7mdk
- more macro (use clean clean_menus)

* Wed Jul 19 2000 Pixel <pixel@mandrakesoft.com> 3.00-6mdk
- macroization
- BM

* Sun Jun 04 2000 David BAUDENS <baudens@mandrakesoft.com> 3.00-5mdk
- Fix %%doc
- Use %%_tmppath for BuildRoot

* Thu Jun  1 2000 Pixel <pixel@mandrakesoft.com> 3.00-4mdk
- change copyright

* Thu Jun  1 2000 Pixel <pixel@mandrakesoft.com> 3.00-3mdk
- takes care of ocamlbrowser and ocamldebug (these must not be stripped)

* Tue May 16 2000 Pixel <pixel@mandrakesoft.com> 3.00-2mdk
- add README to ocaml-emacs

* Mon May  1 2000 Pixel <pixel@mandrakesoft.com> 3.00-1mdk
- new version

* Mon Apr 10 2000 Pixel <pixel@mandrakesoft.com> 2.04-9mdk
- fix groups

* Tue Mar 28 2000 Pixel <pixel@mandrakesoft.com> 2.04-8mdk
- really add menu

* Mon Mar 27 2000 Pixel <pixel@mandrakesoft.com> 2.04-7mdk
- add menu

* Sat Mar 25 2000 Pixel <pixel@mandrakesoft.com> 2.04-6mdk
- new group + cleanup

* Mon Dec  6 1999 Pixel <pixel@linux-mandrake.com>
- 2.04

* Fri Nov 26 1999 Pixel <pixel@linux-mandrake.com>
- 2.03 + cleanup

* Tue Nov 23 1999 Pixel <pixel@linux-mandrake.com>
- build root added

* Tue Jun 01 1999 Pixel <pixel@linux-mandrake.com>
- Hacked to package properly ocamltk

* Tue Dec 29 1998 Alexey Nogin <ayn2@cornell.edu>
- Do not include any /usr/lib/ocaml/*.ml files

* Fri Dec 11 1998 Alexey Nogin <ayn2@cornell.edu>
- Updated to ocaml-2.01

* Sun Nov 29 1998 Alexey Nogin <ayn2@cornell.edu>
- Divided ocaml RPM into ocaml and ocaml-emacs RPMs
  to make it easier to have both ocaml and caml installed
  on the same machine

* Wed Nov 10 1998 Alexey Nogin <ayn2@cornell.edu>
- Changed SRPM according to RHCN Package Requirements
- Added LICENSE, Changelog and README files to the doc directory

